<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xhtml="http://www.w3.org/1999/xhtml" xmlns:sc="http://www.utc.fr/ics/scenari/v3/core" xmlns:redirect="com.scenari.xsldom.xalan.lib.Redirect" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" extension-element-prefixes="redirect" exclude-result-prefixes="sc xhtml" version="1.0">
	<xsl:output omit-xml-declaration="yes" indent="no" method="xml"/>
	<xsl:param name="vDialog"/>
	<xsl:param name="vAgent"/>
	<xsl:template match="treeContent">
		<ul class="mnu_root mnu_sub mnu_static">
			<xsl:apply-templates select="*"/>
		</ul>
	</xsl:template>
	<xsl:template match="entry">
		<xsl:variable name="vClass" select="computeStrDialog(concat(@dialog, '/outlineClasses'))"/>
		<xsl:variable name="vUrl" select="computeStrDialog(string(@dialog), 'act:')"/>
		<xsl:variable name="vSource" select="returnFirst(root,'ext')"/>
		<xsl:variable name="vDepth" select="count(ancestor::entry)"/>
		<xsl:variable name="vPageDialog" select="dialog(string(@dialog))"/>
		<xsl:variable name="vLabel" select="returnFirst(computeStrDialog(concat(@dialog, '/description')),@title)"/>
		<xsl:variable name="vClasses" select="concat('mnu_sel_',if(@position = 'current', 'yes', 'no'),' mnu_src_',$vSource,' mnu_',if(entry,'b','l'),' mnu_dpt_',$vDepth,' ',$vClass)"/>
		<li class="{$vClasses}">
			<xsl:variable name="vSubUrl" select="computeStrDialog(string(entry[1]/@dialog), 'act:')"/>
			<div class="mnuLbl {$vClasses}{if(entry and not(descendant::entry/@position='current' or @position='current'),' mnu_b_c','')}" id="{$vUrl}">
				<xsl:choose>
					<xsl:when test="@position = 'current' or (@position = 'parent' or @position = 'ancestor') and $vSubUrl = $vUrl">
						<span class="mnu_i">
							<span>
								<xsl:value-of select="$vLabel" disable-output-escaping="yes"/>
							</span>
						</span>
					</xsl:when>
					<xsl:otherwise>
						<a href="{$vUrl}" target="_self" class="mnu_i mnu_lnk">
							<span>
								<xsl:value-of select="$vLabel" disable-output-escaping="yes"/>
							</span>
						</a>
					</xsl:otherwise>
				</xsl:choose>
			</div>
			<xsl:if test="entry and (descendant::entry/@position='current' or @position='current')">
				<ul class="mnu_sub">
					<xsl:apply-templates/>
				</ul>
			</xsl:if>
		</li>
	</xsl:template>
	<xsl:template match="node()"/>
</xsl:stylesheet>