<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:lxslt="http://xml.apache.org/xslt" xmlns:redirect="com.scenari.xsldom.xalan.lib.Redirect" xmlns:java="http://xml.apache.org/xslt/java" extension-element-prefixes="redirect java lxslt ">
<xsl:output method="xml" indent="no"/>
<xsl:param name="vDialog"/>
<xsl:param name="vAgent"/>
<xsl:overlay match="head" mode="endHeadTags"><xsl:copy-of select="/descendant::statMgr[@type='ga']/*"/></xsl:overlay>
<xsl:template match="statMgr[@type='ga']"/>
<xsl:overlay match="body" mode="endTags"><xsl:copy-of select="/descendant::statMgr[@type='pa']/*"/></xsl:overlay>
<xsl:template match="statMgr[@type='pa']"/>
<xsl:overlay match="body">
  <xsl:value-of select="execute(java:append($vBufJs, 'tplMgr.init();'))"/>
</xsl:overlay>

<xsl:template match="alternative"><xsl:apply-templates/></xsl:template>
<xsl:template match="@lookForAlt"><xsl:attribute name="alt"><xsl:value-of select="si(.='', ancestor::alternative/@alt, .)"/></xsl:attribute></xsl:template>	
	
<xsl:overlay match="table[contains(@class, 'layout')]">
  <xsl:attribute name="role">presentation</xsl:attribute>
</xsl:overlay>

<xsl:template match="script[contains(@src,'html5shiv.js')]">
<xsl:variable name="vHtml5shiv"><redirect:serialize omit-xml-declaration="yes" method="html"><xsl:copy><xsl:apply-templates select="@*"/></xsl:copy></redirect:serialize></xsl:variable>
<xsl:comment><![CDATA[[if lt IE 9]>]]><xsl:value-of select="$vHtml5shiv"/><![CDATA[<![endif]]]></xsl:comment>
</xsl:template>

<xsl:overlay match="html">
	<xsl:attribute name="lang"><xsl:value-of select="'fr'"/></xsl:attribute>
</xsl:overlay>



<xsl:variable name="vBufJs" select="java:java.lang.StringBuffer.new()"/>
<xsl:overlay match="body" mode="endBodyTags" priority="100"><xsl:if test="java:length($vBufJs) &gt; 0"><script type="text/javascript"><xsl:value-of select="java:toString($vBufJs)"/></script></xsl:if></xsl:overlay>
	
<xsl:template match="secOutMgr">
 <xsl:choose>
  <xsl:when test="count(div[@class='secOutFra']/descendant::a) &lt; 3"><xsl:apply-templates select="div[@class='secOutFra']" mode="supprSecOut"/></xsl:when>
  <xsl:otherwise><xsl:apply-templates select="div[@class='secOutFra']" mode="modSecOut"/></xsl:otherwise>
 </xsl:choose>
 <xsl:apply-overlays select="*[@class!='secOutFra']"/>
 <xsl:apply-templates select="*[@class!='secOutFra']"/>
</xsl:template> 
<xsl:template mode="modSecOut" match="div[@class='secOutFra']">
 <div>
  <xsl:apply-templates select="@*"/>
  <div class="secOutTi"><a class="secOut_op" href="#" onclick="return tplMgr.secOutToggle();"><span>Sommaire </span></a></div>
  <xsl:apply-overlays/>
  <xsl:apply-templates/>
 </div>
</xsl:template> 
<xsl:template mode="supprSecOut" match="*"/>

<xsl:template match="crossRefEntry"><xsl:apply-overlays/><xsl:apply-templates/></xsl:template>
<xsl:overlay match="a[containWord(@class, 'imgZoom')]">
  <xsl:attribute name="onclick">scImgMgr.loading(); return false;</xsl:attribute>
  <xsl:attribute name="title">Cliquez pour agrandir</xsl:attribute>
</xsl:overlay>

<xsl:overlay match="body">
  <xsl:value-of select="execute(java:append($vBufJs, 'scImgMgr.init();'))"/>
</xsl:overlay>

<xsl:template match="@sc-role"><xsl:attribute name="role"><xsl:value-of select="."/></xsl:attribute></xsl:template>
	
<xsl:overlay match="span[contains(@class,'rootTitle')]">
	<xsl:variable name="vIsRich" select="count(descendant::span)+count(descendant::code)+count(descendant::strong)+count(descendant::kbd)>0"/>
	 <xsl:variable name="vTitleLimit" select="number(returnFirst(genProp('dokiel.header.title.limitLength'), '85'))"/> 
 	<xsl:variable name="vTitleLong" select="number(returnFirst(genProp('dokiel.header.title.longLength'), '55'))"/> 
	<xsl:variable name="vLength" select="string-length(normalize-space(.))"/>
	<xsl:attribute name="class">
		<xsl:value-of select="concat(@class, if($vLength > $vTitleLong,' longTitle'),  if($vIsRich,' richTitle'))"/>
	</xsl:attribute>
	<xsl:choose>
		<xsl:when test="$vLength > $vTitleLimit">
			<xsl:value-of select="warning(concat('Le titre du tutoriel est peut-être trop long pour être affiché correctement. Il dépasse les ', $vTitleLimit, ' caractères','(', $vLength,')'))" />
		</xsl:when>
	</xsl:choose>
</xsl:overlay>
<xsl:overlay match="scBlock[contains(@id,'page')]">
	<xsl:variable name="vHasMnu" select="count(//scBlock[@id='outline']/descendant::li)>1"/>
	<xsl:variable name="vHasStk" select="count(//nav[@id='stack']/descendant::span[@class='stkSep'])>0"/>
	<xsl:attribute name="class">
		<xsl:value-of select="concat(@class, if(not($vHasMnu),' tplNoMenu'), if(not($vHasStk),' tplNoStk'))"/>
	</xsl:attribute>
</xsl:overlay>


<xsl:template match="scBlock"><xsl:element name="{returnFirst(@tagName, 'div')}"><xsl:apply-templates select="@*"/><xsl:apply-overlays/><xsl:apply-templates/></xsl:element></xsl:template>
<xsl:template match="scBlock/@noLocalOutline"/>
<xsl:template match="scBlock/@tagName"/>
<xsl:template match="scBlockTitle"/>
	
<xsl:template match="ul[contains(@id,'accessibility')]">
	<xsl:variable name="vHasMnu" select="//*[@id='outline']/descendant::text()[string-length(normalize-space())&gt;0] or //*[@id='outline']/descendant::img or //* [@id='outline']/descendant::object"/>
	<xsl:variable name="vHasNav" select="//*[@id='menu']/descendant::text()[string-length(normalize-space())&gt;0] or //*[@id='menu']/descendant::img or //*[@id='menu']/descendant::object"/>
	<xsl:variable name="vHasExt" select="//*[@id='links']/descendant::text()[string-length(normalize-space())&gt;0] or //*[@id='links']/descendant::img or //*[@id='links']/descendant::object"/>
	<xsl:copy>
		<xsl:apply-templates select="@*"/>
		<xsl:apply-overlays/>
		<xsl:apply-templates select="*[contains(@class, 'Content')]"/>
		<xsl:if test="$vHasMnu">
			<xsl:apply-templates select="*[contains(@class, 'Menu')]"/>
		</xsl:if>
		<xsl:if test="$vHasNav">
			<xsl:apply-templates select="*[contains(@class, 'Nav')]"/>
		</xsl:if>
		<xsl:if test="$vHasExt">
			<xsl:apply-templates select="*[contains(@class, 'Extras')]"/>
		</xsl:if>
	</xsl:copy>
</xsl:template>

<xsl:template match="aboutMgr">
  <xsl:if test="not(/descendant::scBlock[containWord(@class,'about')])">
    <xsl:apply-templates/>
  </xsl:if>
</xsl:template>


<xsl:template match="/"><xsl:apply-overlays/><xsl:apply-templates select="node()"/></xsl:template>
<xsl:template match="head">
<xsl:copy>
<xsl:apply-templates select="@*"/>
<xsl:apply-overlays select="." mode="startHeadTags"/>
<xsl:apply-overlays/>
<xsl:apply-templates/>
<xsl:apply-overlays select="." mode="endHeadTags"/>
</xsl:copy>
</xsl:template>
<xsl:template match="body">
<xsl:copy>
<xsl:apply-templates select="@*"/>
<xsl:apply-overlays select="." mode="startBodyTags"/>
<xsl:apply-overlays select="." mode="startTags"/>
<xsl:apply-overlays/>
<xsl:apply-templates/>
<xsl:apply-overlays select="." mode="endTags"/>
<xsl:apply-overlays select="." mode="endBodyTags"/>
</xsl:copy>
</xsl:template>
<xsl:template match="zoneContent"><xsl:apply-overlays/><xsl:apply-templates/></xsl:template>
<xsl:template match="ifText"><xsl:if test="descendant::text()[string-length(normalize-space())&gt;0] | descendant::img | descendant::object | descendant::input"><xsl:apply-templates/></xsl:if></xsl:template>
<xsl:template name="maxHeadingNumber">6</xsl:template>
<xsl:template match="hx"><xsl:variable name="vCount" select="count(ancestor::scBlock)"/><xsl:variable name="vMaxHx"><xsl:call-template name="maxHeadingNumber"/></xsl:variable><xsl:element name="{concat('h', si($vCount &gt; $vMaxHx, $vMaxHx, $vCount))}"><xsl:apply-templates select="@*"/><xsl:apply-overlays/><xsl:apply-templates/></xsl:element></xsl:template>
<xsl:template match="addAttribute">
<xsl:variable name="vAttCo"><xsl:choose><xsl:when test="@filter='textOnly'"><xsl:value-of select="normalize-space(.)"/></xsl:when><xsl:otherwise><redirect:serialize omit-xml-declaration="yes"><xsl:value-of select="."/></redirect:serialize></xsl:otherwise></xsl:choose></xsl:variable>
<xsl:choose>
<xsl:when test="@name = 'lookForAlt'">
<xsl:attribute name="alt"><xsl:value-of select="si(string($vAttCo)='', ancestor::alternative/@alt, $vAttCo)" disable-output-escaping="yes"/></xsl:attribute>
</xsl:when>
<xsl:otherwise>
<xsl:attribute name="{@name}"><xsl:value-of select="$vAttCo" disable-output-escaping="yes"/></xsl:attribute>
</xsl:otherwise>
</xsl:choose>
</xsl:template>
	
<xsl:template match="outMainMgr">
  <xsl:apply-overlays/>
  <xsl:apply-templates/>
</xsl:template>
<xsl:template match="outMainMgr//li[contains(@class,'outRoot')]/*/span">
 <span>Guide</span>
</xsl:template> 


<xsl:template match="crossRef"/>
<xsl:overlay match="*[crossRef]" priority="1">
<xsl:variable name="vId" select="java:ensureIdOnCurrentResultElt($vDialog, string(crossRef[@prefId]/@prefId))"/>
<xsl:for-each select="crossRef/entry"><xsl:value-of select="java:com.scenari.m.ge.generator.web.CrossRefEntry.addEntry($vDialog, $vId, @keyRef, @value)"/></xsl:for-each>
</xsl:overlay>
	
	<xsl:template match="* | processing-instruction() | comment()"><xsl:copy><xsl:apply-templates select="@*"/><xsl:apply-overlays/><xsl:apply-templates/></xsl:copy></xsl:template>
	<xsl:template match="@* | text()"><xsl:copy/></xsl:template>
</xsl:stylesheet>
