<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" 
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
    xmlns:sc="http://www.utc.fr/ics/scenari/v3/core" 
    xmlns:sp="http://www.utc.fr/ics/scenari/v3/primitive"
    xmlns:dk="kelis.fr:dokiel"    
    xmlns:xalan="http://xml.apache.org/xalan"
    xmlns:redirect="org.apache.xalan.lib.Redirect" 
    extension-element-prefixes="redirect"
    >
    <xsl:output encoding="UTF-8" method="xml"/>
    
    <!-- ### 
        # Retourne le local-name() du modèle fils (internalisé ou externalisé)
        ### -->
    <xsl:template name="tGetSubModelType">
        <xsl:choose>
            <xsl:when test="@sc:refUri"><!-- item externalisé -->
                <xsl:value-of select="local-name(document(concat($pWspPath,'/',@sc:refUri))/*/*[1])"/>
            </xsl:when>
            <xsl:otherwise><!-- item internalisé -->
                <xsl:value-of select="local-name(*[1])"/>
            </xsl:otherwise>
        </xsl:choose>
    </xsl:template>
    
    <!-- ###
        # Permet de remplir le fichier de traces des traitements
        ### -->
    <xsl:template name="tShowMessage">
        <xsl:param name="pMessage"/>
        <xsl:param name="pLevel"/><!-- [warning|error] -->
        <xsl:variable name="vPrefix">
            <xsl:choose>
                <xsl:when test="$pLevel='warning'">- ATTENTION : </xsl:when>
                <xsl:when test="$pLevel='error'">- ERREUR : </xsl:when>
                <xsl:otherwise>- </xsl:otherwise>
            </xsl:choose><xsl:text>[</xsl:text><xsl:value-of select="$pCurrentItemUri"/><xsl:text>] </xsl:text>
        </xsl:variable>
        <redirect:write file="{$pTraceFilePath}" append="true"><log><xsl:value-of select="concat($vPrefix, $pMessage)"/></log></redirect:write>
    </xsl:template>
    
    
</xsl:stylesheet>
