<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:sc="http://www.utc.fr/ics/scenari/v3/core"
    xmlns:sp="http://www.utc.fr/ics/scenari/v3/primitive" xmlns:dk="kelis.fr:dokiel"
    xmlns:xalan="http://xml.apache.org/xalan" xmlns:redirect="org.apache.xalan.lib.Redirect"
    extension-element-prefixes="redirect"
    exclude-result-prefixes="sc sp xalan">

    <xsl:output encoding="UTF-8" method="xml"/>
    <xsl:param name="pCurrentItemUri"/>
    <!--

    <xsl:template match="/*">
        <xsl:copy>
            <xsl:apply-templates select="@*|node()"/>
        </xsl:copy>
    </xsl:template>-->


    <xsl:template match="dk:stepList">
        <dk:stepList>
            <xsl:apply-templates/>
        </dk:stepList>
    </xsl:template>

    <xsl:template match="sp:alt">
        <xsl:choose>
            <xsl:when test="@sc:refUri">
                <sp:alt sc:refUri="{@sc:refUri}">
                    <dk:linkM/>
                </sp:alt>
            </xsl:when>
            <xsl:otherwise>
                <xsl:apply-templates mode="alt"/>
            </xsl:otherwise>
        </xsl:choose>
    </xsl:template>

    <xsl:template match="dk:stepList" mode="alt">
        <sp:alt>
            <xsl:variable name="vFilePathAlt">
                <xsl:value-of select="concat($pWspPath,'/',$pCurrentItemUri, '.', generate-id(), '.xml')"/>
            </xsl:variable>
            <xsl:variable name="vFileUriAlt">
                <xsl:value-of select="concat('/',$pCurrentItemUri, '.', generate-id(), '.xml')"/>
            </xsl:variable>
            <xsl:attribute name="sc:refUri">
                <xsl:value-of select="$vFileUriAlt"/>
            </xsl:attribute>
            <redirect:write file="{$vFilePathAlt}" append="true">
                <sc:item xmlns:sc="http://www.utc.fr/ics/scenari/v3/core">
                    <xsl:copy-of select="."/>
                </sc:item>
            </redirect:write>
            <dk:linkM/>
        </sp:alt>
    </xsl:template>


    <!-- ### 
        # Cas général : on copie
        ### -->
<!--    <xsl:template match="@*|node()">
        <xsl:copy>
            <xsl:apply-templates select="@*|node()"/>
        </xsl:copy>
    </xsl:template>
-->
</xsl:stylesheet>
