<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" 
		xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
		xmlns:sc="http://www.utc.fr/ics/scenari/v3/core" 
		xmlns:sp="http://www.utc.fr/ics/scenari/v3/primitive"
		xmlns:dk="kelis.fr:dokiel"
		xmlns:redirect="com.scenari.xsldtm.xalan.lib.Redirect" 
		extension-element-prefixes="redirect"
		xmlns:xalan="http://xml.apache.org/xalan"
		exclude-result-prefixes="xalan">
	<xsl:output encoding="UTF-8" method="xml"/>
	
	<xsl:param name="pCurrentItemUri"/>
	<xsl:param name="pWspPath"/>
	
	
<!--	### passe les transition en comment
	    # simplification du schémas : on supprime les étapes et programmes pour n'avoir que des modules
	    ###-->
	
<!--	<xsl:template match="/*">
		<xsl:copy>
			<xsl:apply-templates select="@*|node()"/>
		</xsl:copy>
	</xsl:template>-->
	
	
	<xsl:template match="dk:odRoot/sp:guide">
		<xsl:element name="sp:guide">
			<xsl:choose>
				<xsl:when test="@sc:refUri">
					<xsl:attribute name="sc:refUri">
						<xsl:value-of select="concat(substring-before(@sc:refUri,'.xml'), '.scen')"/>
					</xsl:attribute>
				</xsl:when>
				<xsl:otherwise>
					<xsl:apply-templates />
				</xsl:otherwise>
			</xsl:choose>
		</xsl:element>
		<xsl:call-template name="tShowMessage">
			<xsl:with-param name="pMessage">
			Le guide a changé d'extension (.scen) <xsl:value-of select="concat(substring-before(@sc:refUri,'.xml'), '.scen')"/>
			</xsl:with-param>
			</xsl:call-template>
	</xsl:template>
	
	<xsl:template match="dk:odRoot/sp:section">
		<xsl:element name="sp:section">
			<xsl:choose>
				<xsl:when test="@sc:refUri">
					<xsl:attribute name="sc:refUri">
						<xsl:value-of select="concat(substring-before(@sc:refUri,'.xml'), '.scen')"/>
					</xsl:attribute>
					<xsl:apply-templates />
				</xsl:when>
				<xsl:otherwise>
					<xsl:apply-templates />
				</xsl:otherwise>
			</xsl:choose>
		</xsl:element>
		<xsl:call-template name="tShowMessage">
			<xsl:with-param name="pMessage">
			La section a changé d'extension (.scen) <xsl:value-of select="concat(substring-before(@sc:refUri,'.xml'), '.scen')"/>
			</xsl:with-param>
			
			</xsl:call-template>
	</xsl:template>
	
	
	<!-- ### 
		# Cas général : on copie
		### -->
	<!--<xsl:template match="@*|node()">
		<xsl:copy>
			<xsl:apply-templates select="@*|node()"/>
		</xsl:copy>
	</xsl:template>-->
	
</xsl:stylesheet>
