<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" 
		xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
		xmlns:sc="http://www.utc.fr/ics/scenari/v3/core" 
		xmlns:sp="http://www.utc.fr/ics/scenari/v3/primitive"
		xmlns:sfm="http://www.utc.fr/ics/scenari/v3/filemeta"
		xmlns:dk="kelis.fr:dokiel"
		xmlns:pw="scpf.org:presWsp"
		xmlns:xalan="http://xml.apache.org/xalan"
		exclude-result-prefixes="sc sp xalan pw">
	<xsl:output encoding="UTF-8" method="xml"/>
	
	<xsl:param name="pCurrentItemUri"/>
<!--	<xsl:param name="vDialog"/>-->
<!--	<xsl:param name="vAgent"/>-->
	
	<xsl:template match="dk:pwM">
		<dk:pwM>
			<xsl:apply-templates select="sp:logo | sp:cpyRgt | sp:auts | sp:desc"/>
			<xsl:if test="sp:appInfoM/dk:appInfoM/sp:name">
				<sp:vars>
					<sp:vName><xsl:value-of select="sp:appInfoM/dk:appInfoM/sp:name"/></sp:vName>
				</sp:vars>
			</xsl:if>
		</dk:pwM>
	</xsl:template>
	
	<xsl:template match="dk:rootM">
		<dk:rootM>
			<xsl:apply-templates select="sp:version | sp:date | sp:editor | sp:author | sp:copyright | sp:licence | sp:appInfoM"/>
			<xsl:if test="sp:appInfoM/dk:appInfoM/sp:name">
				<sp:vars>
					<sp:vName><xsl:value-of select="sp:appInfoM/dk:appInfoM/sp:name"/></sp:vName>
				</sp:vars>
			</xsl:if>
		</dk:rootM>
	</xsl:template>
	
	<xsl:template match="sp:appInfoM">
		<xsl:comment>
			Cette structure n’est plus reconnue
			<xsl:copy>
				<xsl:apply-templates select="@*|node()" mode="nocomments"/>
			</xsl:copy>
		</xsl:comment>
	</xsl:template>
	
	<xsl:template match="sp:scr[parent::sp:annsettings]">
		
	</xsl:template>
	
	<!-- ### bookRoot ### -->
	<xsl:template match="dk:bookRoot/dk:bookRootM/sp:od">
		<sp:settings>
			<xsl:apply-templates select="@*|node()"/>
		</sp:settings>
	</xsl:template>
	
	<!-- ### tutorialRoot ### -->
	<xsl:template match="dk:tutorialRoot/dk:tutorialRootM/sp:swIcon">
		<sp:logo>
			<xsl:apply-templates select="@*|node()"/>
		</sp:logo>
	</xsl:template>
	
	<!-- ### SWAD ### -->
	<xsl:template match="dk:pres/dk:presM/sp:lic[dk:textSimple]">
		<sp:lic>
			<sp:licCo>
				<xsl:apply-templates select="@*|node()"/>
			</sp:licCo>
		</sp:lic>
	</xsl:template>
	
	
	
	<!-- ### 
		# Cas général : on copie
		### -->
<!--	<xsl:template match="@*|node()">
		<xsl:copy>
			<xsl:apply-templates select="@*|node()"/>
		</xsl:copy>
	</xsl:template> -->
		
</xsl:stylesheet>
