<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xhtml="http://www.w3.org/1999/xhtml" xmlns:sc="http://www.utc.fr/ics/scenari/v3/core" xmlns:redirect="com.scenari.xsldom.xalan.lib.Redirect" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:java="http://xml.apache.org/xslt/java" extension-element-prefixes="redirect" exclude-result-prefixes="sc java xhtml" version="1.0">
	<xsl:output omit-xml-declaration="yes" indent="no" method="xml"/>
	<xsl:param name="vDialog"/>
	<xsl:param name="vAgent"/>
	<xsl:template match="treeContent">{menu:<xsl:apply-templates select="entry[1]"/>,tools:<xsl:apply-templates select="entry[2]">
			<xsl:with-param name="pUseLabel" select="false()"/>
		</xsl:apply-templates>}</xsl:template>
	<xsl:template match="entry">
		<xsl:param name="pUseLabel" select="true()"/>
		<xsl:variable name="vClass" select="resultatDialogue(concat(@dialog, '/outlineClasses'))"/>
		<xsl:variable name="vUrl" select="substring(resultatDialogue(string(@dialog), 'actUri:'),2)"/>
		<xsl:variable name="vPageDialog" select="dialog(string(@dialog))"/>
		<xsl:variable name="vLabel" select="si($pUseLabel,resultatDialogue(concat(@dialog, '/description')),@title)"/>
		<xsl:variable name="vSource" select="returnFirst(root,'unknown')"/>{"url":"<xsl:value-of select="$vUrl"/>","id":"<xsl:value-of select="alphaHash($vUrl)"/>","label":"<serialize><xsl:value-of select="$vLabel" disable-output-escaping="yes"/></serialize>","source":"<xsl:value-of select="chaineProtegeJs($vSource)"/>","className":"<xsl:value-of select="chaineProtegeJs($vClass)"/>"<xsl:if test="entry">,"children":[<xsl:for-each select="entry">
				<xsl:if test="preceding-sibling::entry">,</xsl:if>
				<xsl:apply-templates select=".">
					<xsl:with-param name="pUseLabel" select="$pUseLabel"/>
				</xsl:apply-templates>
			</xsl:for-each>]</xsl:if>}</xsl:template>
	<xsl:template match="node()"/>
</xsl:stylesheet>
